VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMediaTranscode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 08/2022

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const CC_STDCALL As Long = &H4&

Private Const IID_IClosable As String = "{30d5a829-7fa4-4026-83bb-d75bae4ea99e}"
Private Const IID_IAsyncInfo As String = "{00000036-0000-0000-c000-000000000046}"
Private Const IID_IRandomAccessStream As String = "{905a0fe1-bc53-11df-8c49-001e4fc686da}"

Private Const WindowsMediaTranscodingMediaTranscoder As String = "Windows.Media.Transcoding.MediaTranscoder"
Private Const IID_IMediaTranscoder As String = "{190c99d2-a0aa-4d34-86bc-eed1b12c2f5b}"
Private Const IID_IMediaTranscoder2 As String = "{40531d74-35e0-4f04-8574-ca8bc4e5a082}"

Private Const WindowsMediaMediaPropertiesMediaEncodingProfile As String = "Windows.Media.MediaProperties.MediaEncodingProfile"
Private Const IID_IMediaEncodingProfile As String = "{e7dbf5a8-1db9-4783-876b-3dfe12acfdb3}"
Private Const IID_IMediaEncodingProfile2 As String = "{349b3e0a-4035-488e-9877-85632865ed10}"
Private Const IID_IMediaEncodingProfile3 As String = "{ba6ebe88-7570-4e69-accf-5611ad015f88}"
Private Const IID_IMediaEncodingProfileStatics As String = "{197f352c-2ede-4a45-a896-817a4854f8fe}"
Private Const IID_IMediaEncodingProfileStatics2 As String = "{ce8de74f-6af4-4288-8fe2-79adf1f79a43}"
Private Const IID_IMediaEncodingProfileStatics3 As String = "{90dac5aa-cf76-4294-a9ed-1a1420f51f6b}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IUnknown
    IUnknown_QueryInterface = 0
    IUnknown_Release = 2

    ' IInspectable
    IInspectable_GetIids = 3
    IInspectable_GetRuntimeClassName = 4
    IInspectable_GetTrustLevel = 5
    
    ' IAsyncInfo
    IAsyncInfo_GetID = 6
    IAsyncInfo_GetStatus = 7
    IAsyncInfo_GetErrorCode = 8
    IAsyncInfo_Cancel = 9
    IAsyncInfo_Close = 10

    ' IAsyncInterface
    IAsyncInterface_GetResults = 8
    
    ' IClosable
    IClosable_Close = 6

    ' IMediaTranscoder
    IMediaTranscoder_PutTrimStartTime = 6
    IMediaTranscoder_GetTrimStartTime = 7
    IMediaTranscoder_PutTrimStopTime = 8
    IMediaTranscoder_GetTrimStopTime = 9
    IMediaTranscoder_PutAlwaysReencode = 10
    IMediaTranscoder_GetAlwaysReencode = 11
    IMediaTranscoder_PutHardwareAccelerationEnabled = 12
    IMediaTranscoder_GetHardwareAccelerationEnabled = 13
    IMediaTranscoder_AddAudioEffect = 14
    IMediaTranscoder_AddAudioEffectWithSettings = 15
    IMediaTranscoder_AddVideoEffect = 16
    IMediaTranscoder_AddVideoEffectWithSettings = 17
    IMediaTranscoder_ClearEffects = 18
    IMediaTranscoder_PrepareFileTranscodeAsync = 19
    IMediaTranscoder_PrepareStreamTranscodeAsync = 20

    ' IMediaTranscoder2
    IMediaTranscoder2_PrepareMediaStreamSourceTranscodeAsync = 6
    IMediaTranscoder2_PutVideoProcessingAlgorithm = 7
    IMediaTranscoder2_GetVideoProcessingAlgorithm = 8
    
    ' IPrepareTranscodeResult
    IPrepareTranscodeResult_GetCanTranscode = 6
    IPrepareTranscodeResult_GetFailureReason = 7
    IPrepareTranscodeResult_TranscodeAsync = 8
    
    
    ' IMediaEncodingProfile
    IMediaEncodingProfile_PutAudio = 6
    IMediaEncodingProfile_GetAudio = 7
    IMediaEncodingProfile_PutVideo = 8
    IMediaEncodingProfile_GetVideo = 9
    IMediaEncodingProfile_PutContainer = 10
    IMediaEncodingProfile_GetContainer = 11
                        
    ' IMediaEncodingProfile2
    IMediaEncodingProfile2_SetAudioTracks = 6
    IMediaEncodingProfile2_GetAudioTracks = 7
    IMediaEncodingProfile2_SetVideoTracks = 8
    IMediaEncodingProfile2_GetVideoTracks = 9
    
    ' IMediaEncodingProfile3
    IMediaEncodingProfile3_SetTimedMetadataTracks = 6
    IMediaEncodingProfile3_GetTimedMetadataTracks = 7
    
    ' IMediaEncodingProfileStatics
    IMediaEncodingProfileStatics_CreateM4a = 6
    IMediaEncodingProfileStatics_CreateMp3 = 7
    IMediaEncodingProfileStatics_CreateWma = 8
    IMediaEncodingProfileStatics_CreateMp4 = 9
    IMediaEncodingProfileStatics_CreateWmv = 10
    IMediaEncodingProfileStatics_CreateFromFileAsync = 11
    IMediaEncodingProfileStatics_CreateFromStreamAsync = 12
    
    ' IMediaEncodingProfileStatics2
    IMediaEncodingProfileStatics2_CreateWav = 6
    IMediaEncodingProfileStatics2_CreateAvi = 7
    
    ' IMediaEncodingProfileStatics3
    IMediaEncodingProfileStatics3_CreateAlac = 6
    IMediaEncodingProfileStatics3_CreateFlac = 7
    IMediaEncodingProfileStatics3_CreateHevc = 8
    
    ' IAsyncActionWithProgress_Double
    IAsyncActionWithProgress_Double_PutProgress = 6
    IAsyncActionWithProgress_Double_GetProgress = 7
    IAsyncActionWithProgress_Double_PutCompleted = 8
    IAsyncActionWithProgress_Double_GetCompleted = 9
    IAsyncActionWithProgress_Double_GetResults = 10
    
End Enum

Private Enum FileAccessMode
    Read = 0
    ReadWrite = 1
End Enum

Private Enum BSOS_OPTIONS
    BSOS_DEFAULT = 0
    BSOS_PREFERDESTINATIONSTREAM = 1
End Enum

Public Enum AsyncStatus
    Started = 0
    Completed = 1
    Canceled = 2
    Error = 3
End Enum

Public Enum TranscodeFailureReason
    TranscodeFailureReason_None = 0
    TranscodeFailureReason_Unknown = 1
    TranscodeFailureReason_InvalidProfile = 2
    TranscodeFailureReason_CodecNotFound = 3
End Enum

Private Enum TrustLevel
    BaseTrust = 0
    PartialTrust = 1
    FullTrust = 2
End Enum

Public Enum AudioEncodingQuality
    AudioEncodingQuality_Auto = 0
    AudioEncodingQuality_High = 1
    AudioEncodingQuality_Medium = 2
    AudioEncodingQuality_Low = 3
End Enum

Public Enum VideoEncodingQuality
    VideoEncodingQuality_Auto = 0
    VideoEncodingQuality_HD1080p = 1
    VideoEncodingQuality_HD720p = 2
    VideoEncodingQuality_Wvga = 3
    VideoEncodingQuality_Ntsc = 4
    VideoEncodingQuality_Pal = 5
    VideoEncodingQuality_Vga = 6
    VideoEncodingQuality_Qvga = 7
    VideoEncodingQuality_Uhd2160p = 8
    VideoEncodingQuality_Uhd4320p = 9
End Enum

Public Enum AudioProfile
    AudioProfile_M4A = 0  'IMediaEncodingProfileStatics
    AudioProfile_MP3 = 1  'IMediaEncodingProfileStatics
    AudioProfile_WMA = 2  'IMediaEncodingProfileStatics
    AudioProfile_WAV = 3  'IMediaEncodingProfileStatics2
    AudioProfile_ALAC = 4 'IMediaEncodingProfileStatics3
    AudioProfile_FLAC = 5 'IMediaEncodingProfileStatics3
End Enum

Public Enum VideoProfile
    VideoProfile_MP4 'IMediaEncodingProfileStatics
    VideoProfile_WMV 'IMediaEncodingProfileStatics
    VideoProfile_AVI 'IMediaEncodingProfileStatics2
    VideoProfile_HEVC 'IMediaEncodingProfileStatics3
End Enum

Public Enum MediaVideoProcessingAlgorithm
    MediaVideoProcessingAlgorithm_Default = 0
    MediaVideoProcessingAlgorithm_MrfCrf444 = 1
End Enum

Private Enum STGM
    STGM_FAILIFTHERE = 0
    STGM_DIRECT = 0
    STGM_READ = 0
    STGM_WRITE = 1
    STGM_READWRITE = 2
    STGM_SHARE_EXCLUSIVE = &H10
    STGM_SHARE_DENY_WRITE = &H20
    STGM_SHARE_DENY_READ = &H30
    STGM_SHARE_DENY_NONE = &H40
    STGM_CREATE = &H1000
    STGM_TRANSACTED = &H10000
    STGM_CONVERT = &H20000
    STGM_PRIORITY = &H40000
    STGM_NOSCRATCH = &H100000
    STGM_NOSNAPSHOT = &H200000
    STGM_DIRECT_SWMR = &H400000
    STGM_SIMPLE = &H8000000
    STGM_DELETEONRELEASE = &H4000000
End Enum

' ----==== Types ====----
Private Type GUID
    data1 As Long
    data2 As Long
    data3 As Long
    data4 As Long
End Type

' ----==== Ole32.dll Declarations ====----
Private Declare Function CLSIDFromString Lib "ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function StringFromGUID Lib "ole32.dll" _
                         Alias "StringFromGUID2" ( _
                         ByRef rguid As GUID, _
                         ByVal lpsz As Long, _
                         ByVal cchMax As Long) As Long
                         
Private Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                    ByVal hMem As Long)
                         
' ----==== Oleaut32.dll Declarations ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long

' ----==== Kernel32.dll Declarations ====----
Private Declare Sub CopyMemory Lib "kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)

Private Declare Function lstrlenW Lib "kernel32.dll" ( _
                         ByVal lpString As Long) As Long

' ----==== Combase.dll Declarations ====----
Private Declare Function WindowsCreateString Lib "Combase.dll" ( _
                         ByVal sourceString As Long, _
                         ByVal lenght As Long, _
                         ByRef hString As Long) As Long

Private Declare Function WindowsDeleteString Lib "Combase.dll" ( _
                         ByVal sourceString As Long) As Long

Private Declare Function RoGetActivationFactory Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef riid As GUID, _
                         ByRef factory As Long) As Long

Private Declare Function RoActivateInstance Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef instance As Long) As Long

' ----==== ShCore.dll Declarations ====----
Private Declare Function CreateRandomAccessStreamOnFile Lib "ShCore.dll" ( _
                         ByVal filePath As Long, _
                         ByVal accessMode As FileAccessMode, _
                         ByRef riid As GUID, _
                         ByRef ppv As Long) As Long

Private Declare Function CreateRandomAccessStreamOverStream Lib "ShCore.dll" ( _
                         ByVal pStream As Long, _
                         ByVal options As BSOS_OPTIONS, _
                         ByRef riid As GUID, _
                         ByRef ppv As Long) As Long

' ----==== Shlwapi.dll Declarations ====----
Private Declare Function SHCreateStreamOnFileEx Lib "Shlwapi.dll" ( _
                         ByVal pszFile As Long, _
                         ByVal grfMode As STGM, _
                         ByVal dwAttributes As Long, _
                         ByVal fCreate As Long, _
                         ByVal pstmTemplate As Long, _
                         ByRef ppstm As Long) As Long


' ----==== Variablen ====----
Private m_bolIsInitialized As Boolean

Private m_bolAlwaysReencode As Boolean
Private m_bolHardwareAccelerationEnabled As Boolean

Private m_eMediaVideoProcessingAlgorithm As MediaVideoProcessingAlgorithm

Private m_pIMediaTranscoder As Long
Private m_pIMediaTranscoder2 As Long

Private m_pIMediaEncodingProfile As Long
Private m_pIMediaEncodingProfile2 As Long
Private m_pIMediaEncodingProfile3 As Long

Private m_pIMediaEncodingProfileStatics As Long
Private m_pIMediaEncodingProfileStatics2 As Long
Private m_pIMediaEncodingProfileStatics3 As Long

Private m_pIAsyncActionProgressHandler_Double As Long
Private m_pIAsyncActionWithProgressCompletedHandler_Double As Long

' ----==== Temp Variablen ====----
Private m_pTmpIStream As Long
Private m_pTmpIRandomAccessStreamIn As Long
Private m_pTmpIRandomAccessStreamOut As Long
Private m_pTmpIMediaEncodingProfile As Long
Private m_pTmpIPrepareTranscodeResult As Long
Private m_pTmpIAsyncActionWithProgress_Double As Long

' ----==== Events ====----
Public Event CompletedStatus(ByVal Value As AsyncStatus)
Public Event CompletedProgress(ByVal Value As Double)
Public Event FailureReason(ByVal Value As TranscodeFailureReason)

' ----==== Class ====----
Private Sub Class_Initialize()
    m_bolIsInitialized = False
    If CreateMediaTranscoder Then
        If CreateMediaEncodingProfile Then
            If CreateMediaEncodingProfileStatics Then
                If ImplementIAsyncActionProgressHandler Then
                    If ImplementIAsyncActionWithProgressCompletedHandler Then
                        m_bolIsInitialized = True
                    End If
                End If
            End If
        End If
    End If
End Sub

Private Sub Class_Terminate()

    Call Release(m_pIMediaEncodingProfileStatics3)
    Call Release(m_pIMediaEncodingProfileStatics2)
    Call Release(m_pIMediaEncodingProfileStatics)

    Call Release(m_pIMediaEncodingProfile3)
    Call Release(m_pIMediaEncodingProfile2)
    Call Release(m_pIMediaEncodingProfile)

    Call Release(m_pIMediaTranscoder2)
    Call Release(m_pIMediaTranscoder)
    
    modIAsyncActionProgressHandler_Double.Destroy
    modIAsyncActionWithProgressCompletedHandler_Double.Destroy

    m_bolIsInitialized = False
End Sub

' ----==== Properties ====----
Public Property Get IsInitialized() As Boolean
    IsInitialized = m_bolIsInitialized
End Property

Public Property Get AlwaysReencode() As Boolean
    AlwaysReencode = m_bolAlwaysReencode
End Property

Public Property Let AlwaysReencode(Value As Boolean)
    If Me.IsInitialized Then
        If Invoke(m_pIMediaTranscoder, IMediaTranscoder_PutAlwaysReencode, Value) = S_OK Then
            m_bolAlwaysReencode = Value
        End If
    End If
End Property

Public Property Get HardwareAccelerationEnabled() As Boolean
    HardwareAccelerationEnabled = m_bolHardwareAccelerationEnabled
End Property

Public Property Let HardwareAccelerationEnabled(Value As Boolean)
    If Me.IsInitialized Then
        If Invoke(m_pIMediaTranscoder, IMediaTranscoder_PutHardwareAccelerationEnabled, Value) = S_OK Then
            m_bolHardwareAccelerationEnabled = Value
        End If
    End If
End Property

Public Property Get VideoProcessingAlgorithm() As MediaVideoProcessingAlgorithm
    VideoProcessingAlgorithm = m_eMediaVideoProcessingAlgorithm
End Property

Public Property Let VideoProcessingAlgorithm(Value As MediaVideoProcessingAlgorithm)
    If Me.IsInitialized Then
        If Invoke(m_pIMediaTranscoder2, IMediaTranscoder2_PutVideoProcessingAlgorithm, Value) = S_OK Then
            m_eMediaVideoProcessingAlgorithm = Value
        End If
    End If
End Property

' ----==== Subs & Functions ====----
Public Sub TranscodeFileToAudio(ByVal FileIn As String, _
                                ByVal FileOut As String, _
                                ByVal Profile As AudioProfile, _
                                Optional ByVal EncodingQuality As AudioEncodingQuality = AudioEncodingQuality_High)
    Dim bolOk As Boolean
    bolOk = False
    
    If Me.IsInitialized Then
    
        Select Case Profile
            Case AudioProfile.AudioProfile_M4A
                FileOut = FileOut & ".m4a"
                If Invoke(m_pIMediaEncodingProfileStatics, IMediaEncodingProfileStatics_CreateM4a, _
                          EncodingQuality, VarPtr(m_pTmpIMediaEncodingProfile)) = S_OK Then
                    bolOk = True
                End If
                
            Case AudioProfile.AudioProfile_MP3
                FileOut = FileOut & ".mp3"
                If Invoke(m_pIMediaEncodingProfileStatics, IMediaEncodingProfileStatics_CreateMp3, _
                          EncodingQuality, VarPtr(m_pTmpIMediaEncodingProfile)) = S_OK Then
                    bolOk = True
                End If
                
            Case AudioProfile.AudioProfile_WMA
                FileOut = FileOut & ".wma"
                If Invoke(m_pIMediaEncodingProfileStatics, IMediaEncodingProfileStatics_CreateWma, _
                          EncodingQuality, VarPtr(m_pTmpIMediaEncodingProfile)) = S_OK Then
                    bolOk = True
                End If
                
            Case AudioProfile.AudioProfile_WAV
                FileOut = FileOut & ".wav"
                ' Bug! AudioEncodingQuality_Auto geht fr WAV nicht.
                If EncodingQuality = AudioEncodingQuality_Auto Then EncodingQuality = AudioEncodingQuality_High
                If Invoke(m_pIMediaEncodingProfileStatics2, IMediaEncodingProfileStatics2_CreateWav, _
                          EncodingQuality, VarPtr(m_pTmpIMediaEncodingProfile)) = S_OK Then
                    bolOk = True
                End If
                
            Case AudioProfile.AudioProfile_ALAC
                FileOut = FileOut & ".alac"
                If Invoke(m_pIMediaEncodingProfileStatics3, IMediaEncodingProfileStatics3_CreateAlac, _
                          EncodingQuality, VarPtr(m_pTmpIMediaEncodingProfile)) = S_OK Then
                    bolOk = True
                End If
                
            Case AudioProfile.AudioProfile_FLAC
                FileOut = FileOut & ".flac"
                If Invoke(m_pIMediaEncodingProfileStatics3, IMediaEncodingProfileStatics3_CreateFlac, _
                          EncodingQuality, VarPtr(m_pTmpIMediaEncodingProfile)) = S_OK Then
                    bolOk = True
                End If
                
        End Select
                                                      
        If bolOk Then
            bolOk = False
                        
            If LoadAndCreateFiles(FileIn, FileOut) Then
                        
                If Invoke(m_pIMediaTranscoder, IMediaTranscoder_PrepareStreamTranscodeAsync, _
                          m_pTmpIRandomAccessStreamIn, m_pTmpIRandomAccessStreamOut, m_pTmpIMediaEncodingProfile, _
                          VarPtr(m_pTmpIPrepareTranscodeResult)) = S_OK Then
                                  
                    If WaitForAsync(m_pTmpIPrepareTranscodeResult) Then
                                    
                        Dim bolCanTranscode As Boolean
                        If Invoke(m_pTmpIPrepareTranscodeResult, IPrepareTranscodeResult_GetCanTranscode, _
                                  VarPtr(bolCanTranscode)) = S_OK Then
                                
                            If bolCanTranscode Then
                                        
                                RaiseEvent CompletedProgress(0)
                                RaiseEvent CompletedStatus(Started)
                                        
                                If Invoke(m_pTmpIPrepareTranscodeResult, IPrepareTranscodeResult_TranscodeAsync, _
                                          VarPtr(m_pTmpIAsyncActionWithProgress_Double)) = S_OK Then

                                    If Invoke(m_pTmpIAsyncActionWithProgress_Double, IAsyncActionWithProgress_Double_PutProgress, _
                                              m_pIAsyncActionProgressHandler_Double) = S_OK Then
                                            
                                        If Invoke(m_pTmpIAsyncActionWithProgress_Double, IAsyncActionWithProgress_Double_PutCompleted, _
                                                  m_pIAsyncActionWithProgressCompletedHandler_Double) = S_OK Then
                                                
                                            bolOk = True
                                                
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If
    If Not bolOk Then
        Call ReleaseTmpInterfaces
        Kill FileOut
    End If
End Sub

Public Sub TranscodeFileToVideo(ByVal FileIn As String, _
                                ByVal FileOut As String, _
                                ByVal Profile As VideoProfile, _
                                Optional ByVal EncodingQuality As VideoEncodingQuality = VideoEncodingQuality_HD1080p)
    Dim bolOk As Boolean
    bolOk = False
    
    If Me.IsInitialized Then
    
        Select Case Profile
            Case VideoProfile.VideoProfile_MP4
                FileOut = FileOut & ".mp4"
                If Invoke(m_pIMediaEncodingProfileStatics, IMediaEncodingProfileStatics_CreateMp4, _
                          EncodingQuality, VarPtr(m_pTmpIMediaEncodingProfile)) = S_OK Then
                    bolOk = True
                End If
                
            Case VideoProfile.VideoProfile_WMV
                FileOut = FileOut & ".wmv"
                If Invoke(m_pIMediaEncodingProfileStatics, IMediaEncodingProfileStatics_CreateWmv, _
                          EncodingQuality, VarPtr(m_pTmpIMediaEncodingProfile)) = S_OK Then
                    bolOk = True
                End If
                
            Case VideoProfile.VideoProfile_AVI
                FileOut = FileOut & ".avi"
                If Invoke(m_pIMediaEncodingProfileStatics2, IMediaEncodingProfileStatics2_CreateAvi, _
                          EncodingQuality, VarPtr(m_pTmpIMediaEncodingProfile)) = S_OK Then
                    bolOk = True
                End If
                
            Case VideoProfile.VideoProfile_HEVC
                FileOut = FileOut & ".hevc"
                If Invoke(m_pIMediaEncodingProfileStatics3, IMediaEncodingProfileStatics3_CreateHevc, _
                          EncodingQuality, VarPtr(m_pTmpIMediaEncodingProfile)) = S_OK Then
                    bolOk = True
                End If
                
        End Select
                                                      
        If bolOk Then
            bolOk = False
                        
            If LoadAndCreateFiles(FileIn, FileOut) Then
                        
                If Invoke(m_pIMediaTranscoder, IMediaTranscoder_PrepareStreamTranscodeAsync, _
                          m_pTmpIRandomAccessStreamIn, m_pTmpIRandomAccessStreamOut, m_pTmpIMediaEncodingProfile, _
                          VarPtr(m_pTmpIPrepareTranscodeResult)) = S_OK Then
                                  
                    If WaitForAsync(m_pTmpIPrepareTranscodeResult) Then
                                    
                        Dim bolCanTranscode As Boolean
                        If Invoke(m_pTmpIPrepareTranscodeResult, IPrepareTranscodeResult_GetCanTranscode, _
                                  VarPtr(bolCanTranscode)) = S_OK Then
                                
                            If bolCanTranscode Then
                                        
                                RaiseEvent CompletedProgress(0)
                                RaiseEvent CompletedStatus(Started)
                                        
                                If Invoke(m_pTmpIPrepareTranscodeResult, IPrepareTranscodeResult_TranscodeAsync, _
                                          VarPtr(m_pTmpIAsyncActionWithProgress_Double)) = S_OK Then
                                            
                                    If Invoke(m_pTmpIAsyncActionWithProgress_Double, IAsyncActionWithProgress_Double_PutProgress, _
                                              m_pIAsyncActionProgressHandler_Double) = S_OK Then
                                            
                                        If Invoke(m_pTmpIAsyncActionWithProgress_Double, IAsyncActionWithProgress_Double_PutCompleted, _
                                                  m_pIAsyncActionWithProgressCompletedHandler_Double) = S_OK Then
                                                
                                            bolOk = True
                                                
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If
    If Not bolOk Then
        Call ReleaseTmpInterfaces
        Kill FileOut
    End If
End Sub


Private Function LoadAndCreateFiles(ByVal FileIn As String, _
                                    ByVal FileOut As String) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    
    If CreateRandomAccessStreamOnFile(StrPtr(FileIn), Read, _
                                      Str2Guid(IID_IRandomAccessStream), _
                                      m_pTmpIRandomAccessStreamIn) = S_OK Then
            
        If SHCreateStreamOnFileEx(StrPtr(FileOut), STGM_CREATE Or STGM_READWRITE, _
                                  0&, 0&, 0&, m_pTmpIStream) = S_OK Then
            
            If CreateRandomAccessStreamOverStream(m_pTmpIStream, BSOS_DEFAULT, _
                                                  Str2Guid(IID_IRandomAccessStream), _
                                                  m_pTmpIRandomAccessStreamOut) = S_OK Then
                bolRet = True
            End If
        End If
    End If
    LoadAndCreateFiles = bolRet
End Function

Private Sub ReleaseTmpInterfaces()

    Call Release(m_pTmpIAsyncActionWithProgress_Double)
    
    Dim eTranscodeFailureReason As TranscodeFailureReason
    If Invoke(m_pTmpIPrepareTranscodeResult, _
              IPrepareTranscodeResult_GetFailureReason, _
              VarPtr(eTranscodeFailureReason)) = S_OK Then
        RaiseEvent FailureReason(eTranscodeFailureReason)
    End If
    
    Call Release(m_pTmpIPrepareTranscodeResult)
    Call Release(m_pTmpIMediaEncodingProfile)
    Call CloseAndRelease(m_pTmpIRandomAccessStreamOut)
    Call Release(m_pTmpIStream)
    Call CloseAndRelease(m_pTmpIRandomAccessStreamIn)
End Sub

Private Function CreateMediaTranscoder() As Boolean
    Dim bolRet As Boolean
    bolRet = False
    If GetActivateInstance(WindowsMediaTranscodingMediaTranscoder, _
                           IID_IMediaTranscoder, m_pIMediaTranscoder) Then
        If Invoke(m_pIMediaTranscoder, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IMediaTranscoder2)), _
                  VarPtr(m_pIMediaTranscoder2)) = S_OK Then
            If Invoke(m_pIMediaTranscoder, IMediaTranscoder_GetAlwaysReencode, _
                      VarPtr(m_bolAlwaysReencode)) = S_OK Then
                If Invoke(m_pIMediaTranscoder, IMediaTranscoder_GetHardwareAccelerationEnabled, _
                          VarPtr(m_bolHardwareAccelerationEnabled)) = S_OK Then
                    If Invoke(m_pIMediaTranscoder2, IMediaTranscoder2_GetVideoProcessingAlgorithm, _
                              VarPtr(m_eMediaVideoProcessingAlgorithm)) = S_OK Then
                        bolRet = True
                    End If
                End If
            End If
        End If
    End If
    CreateMediaTranscoder = bolRet
End Function

Private Function CreateMediaEncodingProfile() As Boolean
    Dim bolRet As Boolean
    bolRet = False
    If GetActivateInstance(WindowsMediaMediaPropertiesMediaEncodingProfile, _
                           IID_IMediaEncodingProfile, m_pIMediaEncodingProfile) Then
        If Invoke(m_pIMediaEncodingProfile, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IMediaEncodingProfile2)), _
                  VarPtr(m_pIMediaEncodingProfile2)) = S_OK Then
            If Invoke(m_pIMediaEncodingProfile2, IUnknown_QueryInterface, _
                      VarPtr(Str2Guid(IID_IMediaEncodingProfile3)), _
                      VarPtr(m_pIMediaEncodingProfile3)) = S_OK Then
                bolRet = True
            End If
        End If
    End If
    CreateMediaEncodingProfile = bolRet
End Function

Private Function CreateMediaEncodingProfileStatics() As Boolean
    Dim bolRet As Boolean
    bolRet = False
    If GetActivationFactory(WindowsMediaMediaPropertiesMediaEncodingProfile, _
                            IID_IMediaEncodingProfileStatics, _
                            m_pIMediaEncodingProfileStatics) Then
        If Invoke(m_pIMediaEncodingProfileStatics, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IMediaEncodingProfileStatics2)), _
                  VarPtr(m_pIMediaEncodingProfileStatics2)) = S_OK Then
            If Invoke(m_pIMediaEncodingProfileStatics2, IUnknown_QueryInterface, _
                      VarPtr(Str2Guid(IID_IMediaEncodingProfileStatics3)), _
                      VarPtr(m_pIMediaEncodingProfileStatics3)) = S_OK Then
                bolRet = True
            End If
        End If
    End If
    CreateMediaEncodingProfileStatics = bolRet
End Function

Private Function ImplementIAsyncActionProgressHandler() As Boolean
    ImplementIAsyncActionProgressHandler = _
        modIAsyncActionProgressHandler_Double.Create(Me, m_pIAsyncActionProgressHandler_Double)
End Function

Private Function ImplementIAsyncActionWithProgressCompletedHandler() As Boolean
    ImplementIAsyncActionWithProgressCompletedHandler = _
        modIAsyncActionWithProgressCompletedHandler_Double.Create(Me, m_pIAsyncActionWithProgressCompletedHandler_Double)
End Function

Private Function GetActivationFactory(ByVal ClassName As String, _
                                      ByVal IID As String, _
                                      ByRef pFactory As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            If RoGetActivationFactory(hString, Str2Guid(IID), pFactory) = S_OK Then bolRet = True
            Call WindowsDeleteString(hString)
        End If
    End If
    GetActivationFactory = bolRet
End Function

Private Function GetActivateInstance(ByVal ClassName As String, _
                                     ByVal IID As String, _
                                     ByRef pInstance As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            Dim pIInspectable As Long
            If RoActivateInstance(hString, pIInspectable) = S_OK Then
                If pIInspectable <> 0& Then
                    If Invoke(pIInspectable, IUnknown_QueryInterface, _
                              VarPtr(Str2Guid(IID)), VarPtr(pInstance)) = S_OK Then
                        If pInstance <> 0& Then bolRet = True
                    End If
                    Call Release(pIInspectable)
                End If
            End If
            Call WindowsDeleteString(hString)
        End If
    End If
    GetActivateInstance = bolRet
End Function

Private Function WaitForAsync(ByRef pInterface As Long) As Boolean
    Dim bolRet As Boolean
    bolRet = False
    If pInterface <> 0& Then
        Dim pIAsyncInfo As Long
        If Invoke(pInterface, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IAsyncInfo)), _
                  VarPtr(pIAsyncInfo)) = S_OK Then
            Dim eStatus As AsyncStatus
            Do
                If Invoke(pIAsyncInfo, IAsyncInfo_GetStatus, _
                          VarPtr(eStatus)) = S_OK Then DoEvents
            Loop While eStatus = Started
            If eStatus = Completed Then
                bolRet = True
            Else
                Call Invoke(pIAsyncInfo, IAsyncInfo_Close)
            End If
            Call Release(pIAsyncInfo)
            If bolRet Then
                Dim pRet As Long
                If Invoke(pInterface, IAsyncInterface_GetResults, VarPtr(pRet)) = S_OK Then
                    Call Release(pInterface)
                    pInterface = pRet
                End If
            Else
                Call Release(pInterface)
            End If
        End If
    End If
    WaitForAsync = bolRet
End Function

Private Sub Release(ByRef pInterface As Long)
    Dim lngRet As Long
    If pInterface <> 0& Then
        Call Invoke(pInterface, IUnknown_Release)
        pInterface = 0&
    End If
End Sub

Private Function CloseAndRelease(ByRef pInterface As Long) As Long
    Dim lngRet As Long
    If pInterface <> 0& Then
        Dim pIClosable As Long
        If Invoke(pInterface, IUnknown_QueryInterface, _
                  VarPtr(Str2Guid(IID_IClosable)), _
                  VarPtr(pIClosable)) = S_OK Then
            Call Invoke(pIClosable, IClosable_Close)
            Call Release(pIClosable)
            Call Release(pInterface)
            pInterface = 0&
        End If
    End If
    CloseAndRelease = lngRet
End Function

Private Sub GetInspectableInfo(ByVal pInspectableInterface As Long, _
                               ByVal strInterface As String)
    If pInspectableInterface <> 0& Then
        Debug.Print "Inspectable Info for: " & strInterface
        Debug.Print "RuntimeClassName = " & GetInspectable_GetRuntimeClassName(pInspectableInterface)
        Dim eTrustLevel As TrustLevel
        eTrustLevel = GetInspectable_GetTrustLevel(pInspectableInterface)
        Select Case eTrustLevel
            Case TrustLevel.BaseTrust
                Debug.Print "TrustLevel = BaseTrust"
            Case TrustLevel.FullTrust
                Debug.Print "TrustLevel = FullTrust"
            Case TrustLevel.PartialTrust
                Debug.Print "TrustLevel = PartialTrust"
            Case Else
                Debug.Print "TrustLevel = UnknownTrust"
        End Select
        Dim tIIDs() As GUID
        Dim lngIIDsCount As Long
        lngIIDsCount = GetInspectable_GetIIDs(pInspectableInterface, tIIDs)
        Debug.Print "AviableIIDsCount = " & CStr(lngIIDsCount)
        If lngIIDsCount > 0 Then
            Dim lngIIDsItem As Long
            For lngIIDsItem = 0 To lngIIDsCount - 1
                Debug.Print "    AviableIID " & CStr(lngIIDsItem + 1) & _
                            " = " & Guid2Str(tIIDs(lngIIDsItem))
            Next
        End If
        Debug.Print String(60, "-")
    End If
End Sub

Private Function GetInspectable_GetIIDs(ByVal pInterface As Long, _
                                        ByRef tIIDs() As GUID) As Long
    Dim lngIIDCount As Long
    If pInterface <> 0& Then
        Dim pIIDs As Long
        If Invoke(pInterface, IInspectable_GetIids, _
                  VarPtr(lngIIDCount), VarPtr(pIIDs)) = S_OK Then
            If lngIIDCount > 0 Then
                Dim lngBytes As Long
                Dim lngIIDItem As Long
                ReDim tIIDs(lngIIDCount - 1)
                For lngIIDItem = 0 To lngIIDCount - 1
                    lngBytes = Len(tIIDs(lngIIDItem))
                    Call CopyMemory(tIIDs(lngIIDItem), _
                                    ByVal pIIDs + (lngBytes * lngIIDItem), _
                                    lngBytes)
                Next
            End If
        End If
    End If
    GetInspectable_GetIIDs = lngIIDCount
End Function

Private Function GetInspectable_GetRuntimeClassName(ByVal pInterface As Long) As String
    Dim strRet As String
    If pInterface <> 0& Then
        Dim pStr As Long
        If Invoke(pInterface, IInspectable_GetRuntimeClassName, _
                  VarPtr(pStr)) = S_OK Then
            If pStr <> 0& Then strRet = Ptr2Str(pStr)
        End If
    End If
    GetInspectable_GetRuntimeClassName = strRet
End Function

Private Function GetInspectable_GetTrustLevel(ByVal pInterface As Long) As TrustLevel
    Dim eRet As TrustLevel
    If pInterface <> 0& Then
        Dim lngValue As Long
        If Invoke(pInterface, IInspectable_GetTrustLevel, _
                  VarPtr(lngValue)) = S_OK Then
            eRet = lngValue
        End If
    End If
    GetInspectable_GetTrustLevel = eRet
End Function


Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

Private Function OleInvoke(ByVal pInterface As Long, _
                           ByVal lngCmd As Long, _
                           ParamArray aParam()) As Variant
    If pInterface <> 0& Then
        If UBound(aParam) >= 0& Then
            Dim varParam As Variant
            varParam = aParam
            If IsArray(varParam) Then varParam = varParam(0)
            Dim lngCount As Long
            lngCount = UBound(varParam)
            Dim lngItem As Long
            Dim olePtr(10) As Long
            Dim oleTyp(10) As Integer
            For lngItem = 0& To lngCount
                oleTyp(lngItem) = VarType(varParam(lngItem))
                olePtr(lngItem) = VarPtr(varParam(lngItem))
            Next
        End If
        Dim varRet As Variant
        If DispCallFunc(pInterface, lngCmd * 4, CC_STDCALL, _
                        vbLong, lngItem, VarPtr(oleTyp(0)), _
                        VarPtr(olePtr(0)), varRet) <> S_OK Then
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"
        End If

'        If varRet <> S_OK Then
'            Debug.Print "0x" & Hex$(varRet)
'        End If
    End If
    OleInvoke = varRet
End Function

Private Function Str2Guid(ByVal strGUID As String) As GUID
    Call CLSIDFromString(StrPtr(strGUID), Str2Guid)
End Function

Private Function Guid2Str(ByRef tGUID As GUID) As String
    Dim lngRet As Long
    Dim strGUID As String
    strGUID = String(40, 0)
    lngRet = StringFromGUID(tGUID, StrPtr(strGUID), Len(strGUID))
    If lngRet > 0 Then
        strGUID = Left$(strGUID, lngRet - 1)
    Else
        strGUID = vbNullString
    End If
    Guid2Str = strGUID
End Function

Private Function Ptr2Str(ByVal lpStr As Long) As String
    Dim lngLen As Long
    Dim bytBuffer() As Byte
    lngLen = lstrlenW(lpStr) * 2
    If lngLen > 0 Then
        ReDim bytBuffer(lngLen - 1)
        Call CopyMemory(bytBuffer(0), ByVal lpStr, lngLen)
        Call CoTaskMemFree(lpStr)
        Ptr2Str = bytBuffer
    End If
End Function

Public Sub Invoke_IAsyncActionProgressHandler_Double(ByVal asyncInfo As Long, _
                                                     ByVal progressInfo As Double)
    RaiseEvent CompletedProgress(progressInfo)
End Sub

Public Sub Invoke_IAsyncActionWithProgressCompletedHandler_Double(ByVal asyncInfo As Long, _
                                                                  ByVal asyncStat As AsyncStatus)
    RaiseEvent CompletedStatus(asyncStat)
    If asyncStat <> Started Then Call ReleaseTmpInterfaces
End Sub
